!--------1---------2---------3---------4---------5---------6---------7---------8
! 
!> Program  prst_setup
!! @brief   setup restart file for domain decomposition MD
!! @authors Norio Takase (NT)
!
!  (c) Copyright 2014 RIKEN. All rights reserved.
!
!--------1---------2---------3---------4---------5---------6---------7---------8

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

program prst_setup

  use pr_run_prst_setup_mod
  use pr_control_mod
  use messages_mod
  use mpi_parallel_mod

  implicit none

  ! local variables
  character(100)    :: ctrl_filename
  type(s_ctrl_data) :: ctrl_data
  integer           :: ierr


  ! mpi settings
  ! 
  main_rank     = .true.
  my_world_rank = 0
  nproc_world   = 1

  ! show usage
  !
  call usage(ctrl_filename)


  ! [Step1] Read control file
  !
  write(MsgOut,'(A)') '[STEP1] Read Control Parameters for output restart'
  write(MsgOut,'(A)') ' '

  call control(ctrl_filename, ctrl_data)


  ! [Step2] Output restart file
  !
  write(MsgOut,'(A)') '[STEP2] Output parallel I/O restart file'
  write(MsgOut,'(A)') ' '

  call run_prst_setup(ctrl_data)


  stop

end program prst_setup
